#########################################################################################
###### Graph Options
#########################################################################################

#### Acquired Settings:
SETGraphOpt <- list(	Title = "Title of all graphs",
						TitleShow = TRUE,
						Subtitles = c(),
						SubsShow = TRUE,
						XScale = 60,
						XLabel = "Time [min]",
						XLimits = c(10000, 10000),
						YScale = 1,
						YLabel = "Whatever you measure",
						YLimits = c(10000, 10000) )
						
#########################################################################################
#### Graph Options layout
#########################################################################################

####
#### Frame Layout
#################

FRPlotGeneral <- gtkFrame("General")
FRPlotAxis <- gtkFrame("Axes")

LBLGraphOptionsFrame <- gtkLabel("Please fill in all the settings for the graphs (can be refreshed after the analysis is run).")
LBLGraphOptionsFrame$setSizeRequest(-1, 25)

layoutPlotOptions <- gtkVBox(FALSE, 5)
	layoutPlotOptions$packStart(LBLGraphOptionsFrame, expand = FALSE, fill = FALSE)
	layoutPlotOptions$packStart(FRPlotGeneral, expand = FALSE, fill = FALSE)
	layoutPlotOptions$packStart(FRPlotAxis, expand = FALSE, fill = FALSE)

####
#### General Frame
##################

BXPlotGeneral <- gtkVBox(FALSE, 5)
BXPlotGeneral$setBorderWidth(5)
FRPlotGeneral$setBorderWidth(3)
	FRPlotGeneral$add(BXPlotGeneral)

BXPlotGeneralTitle <- gtkHBox(FALSE, 5)
BXPlotSubs <- gtkHBox(FALSE, 5)
BXPlotGeneralSubRaw <- gtkHBox(FALSE, 5)
BXPlotGeneralSubRawOrig <- gtkHBox(FALSE, 5)
BXPlotGeneralSubRawSm <- gtkHBox(FALSE, 5)
BXPlotGeneralSubRawSlope <- gtkHBox(FALSE, 5)
BXPlotGeneralSubRawCons <- gtkHBox(FALSE, 5)
BXPlotGeneralSubRawAv <- gtkHBox(FALSE, 5)
BXPlotGeneralSubRawAvSm <- gtkHBox(FALSE, 5)
BXPlotGeneralSubRawAvSlope <- gtkHBox(FALSE, 5)
BXPlotGeneralSubRawAvCons <- gtkHBox(FALSE, 5)
BXPlotGeneralSubMedium <- gtkHBox(FALSE, 5)
BXPlotGeneralSubMediumOrig <- gtkHBox(FALSE, 5)
BXPlotGeneralSubMediumSm <- gtkHBox(FALSE, 5)
BXPlotGeneralSubMediumSlope <- gtkHBox(FALSE, 5)
BXPlotGeneralSubMediumCons <- gtkHBox(FALSE, 5)
BXPlotGeneralSubMediumAv <- gtkHBox(FALSE, 5)
BXPlotGeneralSubMediumAvSm <- gtkHBox(FALSE, 5)
BXPlotGeneralSubMediumAvSlope <- gtkHBox(FALSE, 5)
BXPlotGeneralSubMediumAvCons <- gtkHBox(FALSE, 5)
BXPlotGeneralSubIC50Time <- gtkHBox(FALSE, 5)
BXPlotGeneralSubIC50Fits <- gtkHBox(FALSE, 5)
	BXPlotGeneral$packStart(BXPlotGeneralTitle, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotSubs, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubRaw, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubRawOrig, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubRawSm, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubRawSlope, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubRawCons, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubRawAv, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubRawAvSm, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubRawAvSlope, expand = FALSE, fill = FALSE)
	BXPlotGeneral$packStart(BXPlotGeneralSubRawAvCons, expand = FALSE, fill = FALSE)

## Title
LBLPlotTitle <- gtkLabel("Title for all graphs:")
LBLPlotTitle$setSizeRequest(250, -1)
CKBPlotTitle <- gtkCheckButton("Show title")
ENTPlotTitle <- gtkEntry()
ENTPlotTitle$setSizeRequest(-1, 20)
	BXPlotGeneralTitle$packStart(LBLPlotTitle, expand = FALSE, fill = FALSE)
	BXPlotGeneralTitle$packStart(CKBPlotTitle, expand = FALSE, fill = FALSE)
	BXPlotGeneralTitle$packStart(ENTPlotTitle, expand = TRUE, fill = TRUE)

## Subtitles
LBLSubs <- gtkLabel("Subtitles for specific graphs:")
LBLSubs$setSizeRequest(250, 30)
CKBSubs <- gtkCheckButton("Show subtitles")
	BXPlotSubs$packStart(LBLSubs, expand = FALSE, fill = FALSE)
	BXPlotSubs$packStart(CKBSubs, expand = FALSE, fill = FALSE)

## Subs Raw
LBLSubRaw <- gtkLabel("Raw data:")
LBLSubRaw$setSizeRequest(250, -1)
ENTSubRaw <- gtkEntry()
ENTSubRaw$setSizeRequest(-1, 20)
	BXPlotGeneralSubRaw$packStart(LBLSubRaw, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubRaw$packStart(ENTSubRaw, expand = TRUE, fill = TRUE)
LBLSubRawOrig <- gtkLabel("Unformatted raw data:")
LBLSubRawOrig$setSizeRequest(250, -1)
ENTSubRawOrig <- gtkEntry()
ENTSubRawOrig$setSizeRequest(-1, 20)
	BXPlotGeneralSubRawOrig$packStart(LBLSubRawOrig, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubRawOrig$packStart(ENTSubRawOrig, expand = TRUE, fill = TRUE)
LBLSubRawSm <- gtkLabel("Smoothed raw data:")
LBLSubRawSm$setSizeRequest(250, -1)
ENTSubRawSm <- gtkEntry()
ENTSubRawSm$setSizeRequest(-1, 20)
	BXPlotGeneralSubRawSm$packStart(LBLSubRawSm, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubRawSm$packStart(ENTSubRawSm, expand = TRUE, fill = TRUE)
LBLSubRawSlope <- gtkLabel("Slope of raw data:")
LBLSubRawSlope$setSizeRequest(250, -1)
ENTSubRawSlope <- gtkEntry()
ENTSubRawSlope$setSizeRequest(-1, 20)
	BXPlotGeneralSubRawSlope$packStart(LBLSubRawSlope, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubRawSlope$packStart(ENTSubRawSlope, expand = TRUE, fill = TRUE)
LBLSubRawCons <- gtkLabel("Consumption from raw data:")
LBLSubRawCons$setSizeRequest(250, -1)
ENTSubRawCons <- gtkEntry()
ENTSubRawCons$setSizeRequest(-1, 20)
	BXPlotGeneralSubRawCons$packStart(LBLSubRawCons, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubRawCons$packStart(ENTSubRawCons, expand = TRUE, fill = TRUE)

## Subs Raw Average
LBLSubRawAv <- gtkLabel("Average raw data:")
LBLSubRawAv$setSizeRequest(250, -1)
ENTSubRawAv <- gtkEntry()
ENTSubRawAv$setSizeRequest(-1, 20)
	BXPlotGeneralSubRawAv$packStart(LBLSubRawAv, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubRawAv$packStart(ENTSubRawAv, expand = TRUE, fill = TRUE)
LBLSubRawAvSm <- gtkLabel("Smoothed average raw data:")
LBLSubRawAvSm$setSizeRequest(250, -1)
ENTSubRawAvSm <- gtkEntry()
ENTSubRawAvSm$setSizeRequest(-1, 20)
	BXPlotGeneralSubRawAvSm$packStart(LBLSubRawAvSm, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubRawAvSm$packStart(ENTSubRawAvSm, expand = TRUE, fill = TRUE)
LBLSubRawAvSlope <- gtkLabel("Slope of average raw data:")
LBLSubRawAvSlope$setSizeRequest(250, -1)
ENTSubRawAvSlope <- gtkEntry()
ENTSubRawAvSlope$setSizeRequest(-1, 20)
	BXPlotGeneralSubRawAvSlope$packStart(LBLSubRawAvSlope, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubRawAvSlope$packStart(ENTSubRawAvSlope, expand = TRUE, fill = TRUE)
LBLSubRawAvCons <- gtkLabel("Consumption from average raw data:")
LBLSubRawAvCons$setSizeRequest(250, -1)
ENTSubRawAvCons <- gtkEntry()
ENTSubRawAvCons$setSizeRequest(-1, 20)
	BXPlotGeneralSubRawAvCons$packStart(LBLSubRawAvCons, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubRawAvCons$packStart(ENTSubRawAvCons, expand = TRUE, fill = TRUE)
	
## Subs Medium
LBLSubMedium <- gtkLabel("Normalisation:")
LBLSubMedium$setSizeRequest(250, -1)
ENTSubMedium <- gtkEntry()
ENTSubMedium$setSizeRequest(-1, 20)
	BXPlotGeneralSubMedium$packStart(LBLSubMedium, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubMedium$packStart(ENTSubMedium, expand = TRUE, fill = TRUE)
LBLSubMediumOrig <- gtkLabel("Unformatted normalisation:")
LBLSubMediumOrig$setSizeRequest(250, -1)
ENTSubMediumOrig <- gtkEntry()
ENTSubMediumOrig$setSizeRequest(-1, 20)
	BXPlotGeneralSubMediumOrig$packStart(LBLSubMediumOrig, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubMediumOrig$packStart(ENTSubMediumOrig, expand = TRUE, fill = TRUE)
LBLSubMediumSm <- gtkLabel("Smoothed normalisation:")
LBLSubMediumSm$setSizeRequest(250, -1)
ENTSubMediumSm <- gtkEntry()
ENTSubMediumSm$setSizeRequest(-1, 20)
	BXPlotGeneralSubMediumSm$packStart(LBLSubMediumSm, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubMediumSm$packStart(ENTSubMediumSm, expand = TRUE, fill = TRUE)
LBLSubMediumSlope <- gtkLabel("Slope of normalisation:")
LBLSubMediumSlope$setSizeRequest(250, -1)
ENTSubMediumSlope <- gtkEntry()
ENTSubMediumSlope$setSizeRequest(-1, 20)
	BXPlotGeneralSubMediumSlope$packStart(LBLSubMediumSlope, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubMediumSlope$packStart(ENTSubMediumSlope, expand = TRUE, fill = TRUE)
LBLSubMediumCons <- gtkLabel("Consumption from normalisation:")
LBLSubMediumCons$setSizeRequest(250, -1)
ENTSubMediumCons <- gtkEntry()
ENTSubMediumCons$setSizeRequest(-1, 20)
	BXPlotGeneralSubMediumCons$packStart(LBLSubMediumCons, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubMediumCons$packStart(ENTSubMediumCons, expand = TRUE, fill = TRUE)

## Subs Medium Average
LBLSubMediumAv <- gtkLabel("Average normalisation:")
LBLSubMediumAv$setSizeRequest(250, -1)
ENTSubMediumAv <- gtkEntry()
ENTSubMediumAv$setSizeRequest(-1, 20)
	BXPlotGeneralSubMediumAv$packStart(LBLSubMediumAv, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubMediumAv$packStart(ENTSubMediumAv, expand = TRUE, fill = TRUE)
LBLSubMediumAvSm <- gtkLabel("Smoothed average normalisation:")
LBLSubMediumAvSm$setSizeRequest(250, -1)
ENTSubMediumAvSm <- gtkEntry()
ENTSubMediumAvSm$setSizeRequest(-1, 20)
	BXPlotGeneralSubMediumAvSm$packStart(LBLSubMediumAvSm, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubMediumAvSm$packStart(ENTSubMediumAvSm, expand = TRUE, fill = TRUE)
LBLSubMediumAvSlope <- gtkLabel("Slope of average medium normalisation:")
LBLSubMediumAvSlope$setSizeRequest(250, -1)
ENTSubMediumAvSlope <- gtkEntry()
ENTSubMediumAvSlope$setSizeRequest(-1, 20)
	BXPlotGeneralSubMediumAvSlope$packStart(LBLSubMediumAvSlope, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubMediumAvSlope$packStart(ENTSubMediumAvSlope, expand = TRUE, fill = TRUE)
LBLSubMediumAvCons <- gtkLabel("Consumption from average normalisation:")
LBLSubMediumAvCons$setSizeRequest(250, -1)
ENTSubMediumAvCons <- gtkEntry()
ENTSubMediumAvCons$setSizeRequest(-1, 20)
	BXPlotGeneralSubMediumAvCons$packStart(LBLSubMediumAvCons, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubMediumAvCons$packStart(ENTSubMediumAvCons, expand = TRUE, fill = TRUE)

## Subs IC50
LBLSubIC50Time <- gtkLabel("Timeresolved IC50:")
LBLSubIC50Time$setSizeRequest(250, -1)
ENTSubIC50Time <- gtkEntry()
ENTSubIC50Time$setSizeRequest(-1, 20)
	BXPlotGeneralSubIC50Time$packStart(LBLSubIC50Time, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubIC50Time$packStart(ENTSubIC50Time, expand = TRUE, fill = TRUE)
LBLSubIC50Fits <- gtkLabel("Single IC50 fits:")
LBLSubIC50Fits$setSizeRequest(250, -1)
ENTSubIC50Fits <- gtkEntry()
ENTSubIC50Fits$setSizeRequest(-1, 20)
	BXPlotGeneralSubIC50Fits$packStart(LBLSubIC50Fits, expand = FALSE, fill = FALSE)
	BXPlotGeneralSubIC50Fits$packStart(ENTSubIC50Fits, expand = TRUE, fill = TRUE)

####
#### Axes Frame
###############

BXPlotAxes <- gtkVBox(FALSE, 5)
BXPlotAxes$setBorderWidth(5)
FRPlotAxis$setBorderWidth(3)
	FRPlotAxis$add(BXPlotAxes)

BXPlotAxesH2 <- gtkHBox(FALSE, 5) #XLabel
BXPlotAxesH3 <- gtkHBox(FALSE, 5) #XLimits
LBLPlotAxesH3Spacer <- gtkLabel("")
BXPlotAxesH4 <- gtkHBox(FALSE, 5) #YScale
BXPlotAxesH5 <- gtkHBox(FALSE, 5) #YLabel
BXPlotAxesH6 <- gtkHBox(FALSE, 5) #YLimits
	BXPlotAxes$packStart(BXPlotAxesH2, expand = FALSE, fill = FALSE)
	BXPlotAxes$packStart(BXPlotAxesH3, expand = FALSE, fill = FALSE)
	BXPlotAxes$packStart(LBLPlotAxesH3Spacer, expand = FALSE, fill = FALSE)
	BXPlotAxes$packStart(BXPlotAxesH5, expand = FALSE, fill = FALSE)
	BXPlotAxes$packStart(BXPlotAxesH6, expand = FALSE, fill = FALSE)

## Axes H2
LBLPlotAxesH2 <- gtkLabel("X-axis label:")
LBLPlotAxesH2$setSizeRequest(200, -1)
ENTPlotAxesH2 <- gtkEntry()
ENTPlotAxesH2$setSizeRequest(-1, 20)
	BXPlotAxesH2$packStart(LBLPlotAxesH2, expand = FALSE, fill = FALSE)
	BXPlotAxesH2$packStart(ENTPlotAxesH2, expand = TRUE, fill = TRUE)

## Axes H3
LBLPlotAxesH3 <- gtkLabel("X-axis limits:")
LBLPlotAxesH3$setSizeRequest(200, -1)
LBLPlotAxesH3min <- gtkLabel("min =")
LBLPlotAxesH3max <- gtkLabel("max =")
ENTPlotAxesH3min <- gtkEntry()
ENTPlotAxesH3min$setSizeRequest(60, 20)
ENTPlotAxesH3max <- gtkEntry()
ENTPlotAxesH3max$setSizeRequest(60, 20)
LBLPlotAxesH3exp <- gtkLabel("(enter 10000 for automatic limits)")
	BXPlotAxesH3$packStart(LBLPlotAxesH3, expand = FALSE, fill = FALSE)
	BXPlotAxesH3$packStart(LBLPlotAxesH3min, expand = FALSE, fill = FALSE)
	BXPlotAxesH3$packStart(ENTPlotAxesH3min, expand = FALSE, fill = FALSE)
	BXPlotAxesH3$packStart(LBLPlotAxesH3max, expand = FALSE, fill = FALSE)
	BXPlotAxesH3$packStart(ENTPlotAxesH3max, expand = FALSE, fill = FALSE)
	BXPlotAxesH3$packStart(LBLPlotAxesH3exp, expand = FALSE, fill = FALSE)
	
## Axes H5
LBLPlotAxesH5 <- gtkLabel("Y-axis label:")
LBLPlotAxesH5$setSizeRequest(200, -1)
ENTPlotAxesH5 <- gtkEntry()
ENTPlotAxesH5$setSizeRequest(-1, 20)
	BXPlotAxesH5$packStart(LBLPlotAxesH5, expand = FALSE, fill = FALSE)
	BXPlotAxesH5$packStart(ENTPlotAxesH5, expand = TRUE, fill = TRUE)

## Axes H6
LBLPlotAxesH6 <- gtkLabel("Y-axis limits:")
LBLPlotAxesH6$setSizeRequest(200, -1)
LBLPlotAxesH6min <- gtkLabel("min =")
LBLPlotAxesH6max <- gtkLabel("max =")
ENTPlotAxesH6min <- gtkEntry()
ENTPlotAxesH6min$setSizeRequest(60, 20)
ENTPlotAxesH6max <- gtkEntry()
ENTPlotAxesH6max$setSizeRequest(60, 20)
LBLPlotAxesH6exp <- gtkLabel("(enter 10000 for automatic limits)")
	BXPlotAxesH6$packStart(LBLPlotAxesH6, expand = FALSE, fill = FALSE)
	BXPlotAxesH6$packStart(LBLPlotAxesH6min, expand = FALSE, fill = FALSE)
	BXPlotAxesH6$packStart(ENTPlotAxesH6min, expand = FALSE, fill = FALSE)
	BXPlotAxesH6$packStart(LBLPlotAxesH6max, expand = FALSE, fill = FALSE)
	BXPlotAxesH6$packStart(ENTPlotAxesH6max, expand = FALSE, fill = FALSE)
	BXPlotAxesH6$packStart(LBLPlotAxesH6exp, expand = FALSE, fill = FALSE)

#########################################################################################
#### Graph Options interactive
#########################################################################################

####
#### Signal: Entry for Title
############################
gSignalConnect(ENTPlotTitle, "activate", quote({
	text <- ENTPlotTitle$getText()
	SETGraphOpt$Title <- text
}))

####
#### Signal: Show Title
#######################
gSignalConnect(CKBPlotTitle, "toggled", quote({
	value <- CKBPlotTitle$getActive()
	SETGraphOpt$TitleShow <- value
	ENTPlotTitle[["editable"]] <- value
}))

####
#### Signal: Show Subtitles
###########################
gSignalConnect(CKBSubs, "toggled", quote({
	value <- CKBSubs$getActive()
	SETGraphOpt$SubsShow <- value
	## Implement editable function for all entryboxes
}))

####
#### Signal: Entry for Subtitles
################################
FCollectSubtitles <- function() {}

####
#### Signal: Entry for X Label
##############################
gSignalConnect(ENTPlotAxesH2, "activate", quote({
	SETGraphOpt$XLabel <- ENTPlotAxesH2$getText()
}))

####
#### Signal: Limits for X-axis
##############################
ERRLimitsX <- gtkLabel("-- Please enter numbers for the X-axis limits! --")
	ERRLimitsX["visible"] <- FALSE
	BXErrormessages$packStart(ERRLimitsX, expand = TRUE, fill = TRUE)
ValidMinX <- 1
ValidMaxX <- 1

gSignalConnect(ENTPlotAxesH3min, "activate", quote({
	text <- as.numeric(ENTPlotAxesH3min$getText())
	if (is.na(text) == TRUE) {
		ERRLimitsX["visible"] <- TRUE
		ValidMinX <- 0
	} else {
		SETGraphOpt$XLimits[1] <- text
		ValidMinX <- 1
	}
	if (ValidMinX == 1 & ValidMaxX == 1) {
		ERRLimitsX["visible"] <- FALSE
	}
	#print(SETGraphOpt$XLimits)
}))
gSignalConnect(ENTPlotAxesH3max, "activate", quote({
	text <- as.numeric(ENTPlotAxesH3max$getText())
	if (is.na(text) == TRUE) {
		ERRLimitsX["visible"] <- TRUE
		ValidMaxX <- 0
	} else {
		SETGraphOpt$XLimits[2] <- text
		ValidMaxX <- 1
	}
	if (ValidMinX == 1 & ValidMaxX == 1) {
		ERRLimitsX["visible"] <- FALSE
	}
	#print(SETGraphOpt$XLimits)
}))

####
#### Signal: Entry for Y Label
##############################
gSignalConnect(ENTPlotAxesH5, "activate", quote({
	text <- ENTPlotAxesH5$getText()
	SETGraphOpt$YLabel <- text
}))

####
#### Signal: Limits for Y-axis
##############################
ERRLimitsY <- gtkLabel("-- Please enter numbers for the Y-axis limits! --")
	ERRLimitsY["visible"] <- FALSE
	BXErrormessages$packStart(ERRLimitsY, expand = TRUE, fill = TRUE)
ValidMinY <- 1
ValidMaxY <- 1

gSignalConnect(ENTPlotAxesH6min, "activate", quote({
	text <- as.numeric(ENTPlotAxesH6min$getText())
	if (is.na(text) == TRUE) {
		ERRLimitsY["visible"] <- TRUE
		ValidMinY <- 0
	} else {
		SETGraphOpt$YLimits[1] <- text
		ValidMinY <- 1
	}
	if (ValidMinY == 1 & ValidMaxY == 1) {
		ERRLimitsY["visible"] <- FALSE
	}
	#print(SETGraphOpt$YLimits)
}))
gSignalConnect(ENTPlotAxesH6max, "activate", quote({
	text <- as.numeric(ENTPlotAxesH6max$getText())
	if (is.na(text) == TRUE) {
		ERRLimitsY["visible"] <- TRUE
		ValidMaxY <- 0
	} else {
		SETGraphOpt$YLimits[2] <- text
		ValidMaxY <- 1
	}
	if (ValidMinY == 1 & ValidMaxY == 1) {
		ERRLimitsY["visible"] <- FALSE
	}
	#print(SETGraphOpt$YLimits)
}))

#########################################################################################
#### Graph Options execute
#########################################################################################

#### Create vector containing all elements to check again before execution
CheckInputGraphOpt <- c(ENTPlotTitle, ENTPlotAxesH2, ENTPlotAxesH3min, ENTPlotAxesH3max, ENTPlotAxesH5, ENTPlotAxesH6min, ENTPlotAxesH6max)

####
#### Function: Activate all Input for Graph Options
#####################################################
FCheckGraphOpt <- function(Input) {
	for (i in 1:length(Input)) {
		if (class(Input[[i]])[1] == "GtkRadioButton") {
			gSignalEmit(Input[[i]], "toggled")
		} else if (class(Input[[i]])[1] == "GtkEntry") {
			gSignalEmit(Input[[i]], "activate")
		}
	}
	FCollectSubtitles()
}