#########################################################################################
###### Graph output
#########################################################################################

#### Acquired Settings:
SETGraphOutput <- list(  Scalebar = c("pt" = 10, "columns" = 4, "position" = 1, "lwd" = 1, "grid" = 50, "error" = 20, "whitespace" = 0.51),
                         IC50 = c(diff = "colour", type = "average") )

####
#### Function: Refresh Graph
############################
FRefreshGraph <- function() {
  if (LBLCurrentGraphData$getLabel() == "Raw data") gSignalEmit(btnRawShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Unformatted raw data") gSignalEmit(btnRawOrigShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Raw data smoothed") gSignalEmit(btnRawSmShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Raw data slope") gSignalEmit(btnRawSlopeShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Raw data consumption") gSignalEmit(btnRawConsShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Average raw data") gSignalEmit(btnRawAvShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Average raw data smoothed") gSignalEmit(btnRawAvSmShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Average raw data slope") gSignalEmit(btnRawAvSlopeShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Average raw data consumption") gSignalEmit(btnRawAvConsShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Sensor corrected data") gSignalEmit(btnOxoDishShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Unformatted sensor corrected data") gSignalEmit(btnOxoDishOrigShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Sensor corrected data smoothed") gSignalEmit(btnOxoDishSmShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Sensor corrected data slope") gSignalEmit(btnOxoDishSlopeShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Sensor corrected data consumption") gSignalEmit(btnOxoDishConsShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Average sensor corrected data") gSignalEmit(btnOxoDishAvShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Average sensor corrected data smoothed") gSignalEmit(btnOxoDishAvSmShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Average sensor corrected data slope") gSignalEmit(btnOxoDishAvSlopeShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Average sensor corrected data consumption") gSignalEmit(btnOxoDishAvConsShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Converted OxoPlate data") gSignalEmit(btnOxoPlateShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Unformatted OxoPlate data") gSignalEmit(btnOxoPlateOrigShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "OxoPlate data smoothed") gSignalEmit(btnOxoPlateSmShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "OxoPlate data slope") gSignalEmit(btnOxoPlateSlopeShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "OxoPlate data consumption") gSignalEmit(btnOxoPlateConsShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Average OxoPlate data") gSignalEmit(btnOxoPlateAvShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Average OxoPlate data smoothed") gSignalEmit(btnOxoPlateAvSmShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Average OxoPlate data slope") gSignalEmit(btnOxoPlateAvSlopeShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Average OxoPlate data consumption") gSignalEmit(btnOxoPlateAvConsShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Converted HydroPlate data") gSignalEmit(btnHydroPlateShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Unformatted converted HydroPlate data") gSignalEmit(btnHydroPlateOrigShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Calibration values for HydroPlate data") gSignalEmit(btnHydroPlateCalShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "HydroPlate data smoothed") gSignalEmit(btnHydroPlateSmShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "HydroPlate data slope") gSignalEmit(btnHydroPlateSlopeShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Average HydroPlate data") gSignalEmit(btnHydroPlateAvShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Average HydroPlate data smoothed") gSignalEmit(btnHydroPlateAvSmShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Average HydroPlate data slope") gSignalEmit(btnHydroPlateAvSlopeShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Medium data") gSignalEmit(btnMediumShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Unformatted medium data") gSignalEmit(btnMediumOrigShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Medium data smoothed") gSignalEmit(btnMediumSmShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Medium data slope") gSignalEmit(btnMediumSlopeShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Medium data consumption") gSignalEmit(btnMediumConsShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Average medium data") gSignalEmit(btnMediumAvShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Average medium data smoothed") gSignalEmit(btnMediumAvSmShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Average medium data slope") gSignalEmit(btnMediumAvSlopeShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Average medium data consumption") gSignalEmit(btnMediumAvConsShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "Timeresolved IC50 data") gSignalEmit(btnIC50TimeShow, "clicked")
  else if (LBLCurrentGraphData$getLabel() == "IC50 fitting data") gSignalEmit(btnIC50FitShow, "clicked")
}

####
#### Function: Updated data sets
################################
FNotificationDataUpdate <- function() {
  POPNotificationDataUpdate <- gtkMessageDialog(mainApplication, "destroy-with-parent", "error", buttons = "ok", "Please be aware that the basis for the displayed data set changed.")
  if (POPNotificationDataUpdate$run() == GtkResponseType["ok"]) POPNotificationDataUpdate$destroy()
  else POPNotificationDataUpdate$destroy()
}

#########################################################################################
#### Graph output Layout
#########################################################################################

####
#### Frame layout
#################

FRLineSel <- gtkFrame("Lineselection")
BXMiniatur <- gtkVBox(FALSE, 2)
BXMiniatur$setBorderWidth(5)
BXCurrentGraph <- gtkVBox(FALSE, 5)
BXCurrentGraph$setBorderWidth(5)

layoutGraphs <- gtkHBox(FALSE, 5)
layoutGraphs$packStart(FRLineSel, expand = FALSE, fill = FALSE)
layoutGraphs$packStart(BXCurrentGraph, expand = TRUE, fill = TRUE)
layoutGraphs$packStart(BXMiniatur, expand = FALSE, fill = FALSE)

####
#### LineSelection Frame
########################
SCRLineSelect <- gtkScrolledWindow()
SCRLineSelect$setPolicy("automatic", "automatic")
SCRLineSelect$setSizeRequest(120, -1)
BXLineSel <- gtkVBox(FALSE, 3)
BXLineSelect <- gtkVBox(FALSE, 5)
FRLineSel$setBorderWidth(5)
FRLineSel$add(BXLineSelect)
BXLineSelect$packStart(SCRLineSelect, expand = TRUE, fill = TRUE)
SCRLineSelect$addWithViewport(BXLineSel)

####
#### Function: Construct the Checkboxes for the currectly shown graph
#####################################################################
FCheckboxConstruct <- function(D) {
  ## Clear list
  Checkboxes <- list()
  removeCheckboxes <- BXLineSel$getChildren()
  if (length(removeCheckboxes) != 0) {
    for (i in 1: length(removeCheckboxes)) BXLineSel$remove(removeCheckboxes[[i]])
  }
  
  ## Produce list for data set
  for (i in 2:dim(D)[2]) {
    Checkboxes[[paste("check", i, sep = "")]] <- gtkCheckButton(label = names(D)[i])
    if (length(SETGraphOutput[[LBLCurrentGraphData$getLabel()]]) != 0) {
      if (SETGraphOutput[[LBLCurrentGraphData$getLabel()]][i-1] == TRUE) {
        Checkboxes[[paste("check", i, sep = "")]]$setActive(is.active = TRUE)
      } else {
        Checkboxes[[paste("check", i, sep = "")]]$setActive(is.active = FALSE)
      }
    } else {
      Checkboxes[[paste("check", i, sep = "")]]$setActive(is.active = TRUE)
    }
    BXLineSel$packStart(Checkboxes[[paste("check", i, sep="")]], expand = FALSE, fill = FALSE)
  }
  Checkboxes <<- Checkboxes
  FLinesGetSettings()
}

## Buttons
btnLineSelectAll <- gtkButton("Select all")
btnLineSelectNone <- gtkButton("Select none")
BXLineSelect$packEnd(btnLineSelectNone, expand = FALSE, fill = FALSE)
BXLineSelect$packEnd(btnLineSelectAll, expand = FALSE, fill = FALSE)

####
#### Current Graph
##################
## Display Drawing Area
# Automatically produced drawing area will replace the label. See Analyser
LBLCurrentGraph <- gtkLabel("Please select a graph from the right side.")
BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)

## Buttons
BXCurrentButtons <- gtkHButtonBox(TRUE)
BXCurrentButtonsLay <- gtkHBox(FALSE, 5)
btnCurrentRefreshLines <- gtkButton("Refresh lines")
btnCurrentRefreshSet <- gtkButton("Refresh options")
btnCurrentExport <- gtkButton("Export displayed graph")
LBLCurrentGraphData <- gtkLabel("Current Data")
BXCurrentButtons$packStart(btnCurrentRefreshLines, expand = FALSE, fill = FALSE)
BXCurrentButtons$packStart(btnCurrentRefreshSet, expand = FALSE, fill = FALSE)
BXCurrentButtons$packStart(btnCurrentExport, expand = FALSE, fill = FALSE)
BXCurrentButtonsLay$packStart(LBLCurrentGraphData, expand = TRUE, fill = TRUE)
BXCurrentButtonsLay$packEnd(BXCurrentButtons, expand = FALSE, fill = FALSE)
BXCurrentGraph$packEnd(BXCurrentButtonsLay, expand = FALSE, fill = FALSE)

## Standard deviation
BXCurrentGraphSettings <- gtkHBox(FALSE, 5)
CKBShowSd <- gtkCheckButton("Show standard deviation")
CKBShowSd$setSizeRequest(200, -1)
BXCurrentGraphSettings$packStart(CKBShowSd, expand = FALSE, fill = FALSE)

## Scalebar:
COMScalebar <- gtkComboBoxNewText()
COMScalebar[["height-request"]] <- 38
COMScalebar$appendText("Point size:")
COMScalebar$appendText("Legend columns:")
COMScalebar$appendText("Legend position:")
COMScalebar$appendText("Line width:")
COMScalebar$appendText("Grid colour intensity:")
COMScalebar$appendText("Error colour intensity:")
COMScalebar$appendText("White space:")
COMScalebar$setActive("0")
BXCurrentGraphSettings$packStart(COMScalebar, expand = FALSE, fill = FALSE)

BXCurrentGraph$packEnd(BXCurrentGraphSettings, expand = FALSE, fill = FALSE)

## Radio Buttons for IC50 fits
BXCurrentGraphIC50 <- gtkVBox(FALSE, 5)
BXCurrentGraph$packEnd(BXCurrentGraphIC50, expand = FALSE, fill = FALSE)
BXCurrentGraphIC50Diff <- gtkHBox(FALSE, 5)
BXCurrentGraphIC50Type <- gtkHBox(FALSE, 5)
BXCurrentGraphIC50$packStart(BXCurrentGraphIC50Diff, expand = FALSE, fill = FALSE)
BXCurrentGraphIC50$packStart(BXCurrentGraphIC50Type, expand = FALSE, fill = FALSE)

LBLCurrentGraphIC50Diff <- gtkLabel("Differentiate between time points by varying")
btnCurrentGraphIC50DiffCol <- gtkRadioButton(group = NULL, "colour")
btnCurrentGraphIC50DiffLty <- gtkRadioButton(group = c(btnCurrentGraphIC50DiffCol), "linetype / symbols")
btnCurrentGraphIC50DiffNone <- gtkRadioButton(group = c(btnCurrentGraphIC50DiffCol), "nothing (all black and solid).")
BXCurrentGraphIC50Diff$packStart(LBLCurrentGraphIC50Diff, expand = FALSE, fill = FALSE)
BXCurrentGraphIC50Diff$packStart(btnCurrentGraphIC50DiffCol, expand = FALSE, fill = FALSE)
BXCurrentGraphIC50Diff$packStart(btnCurrentGraphIC50DiffLty, expand = FALSE, fill = FALSE)
BXCurrentGraphIC50Diff$packStart(btnCurrentGraphIC50DiffNone, expand = FALSE, fill = FALSE)

LBLCurrentGraphIC50Type <- gtkLabel("Display")
btnCurrentGraphIC50TypeNone <- gtkRadioButton(group = NULL, "curve only")
btnCurrentGraphIC50TypeObs <- gtkRadioButton(group = c(btnCurrentGraphIC50TypeNone), "observations only")
btnCurrentGraphIC50TypeAll <- gtkRadioButton(group = c(btnCurrentGraphIC50TypeNone), "observations + curve")
btnCurrentGraphIC50TypeAv <- gtkRadioButton(group = c(btnCurrentGraphIC50TypeNone), "average + curve")
btnCurrentGraphIC50TypeBars <- gtkRadioButton(group = c(btnCurrentGraphIC50TypeNone), "curve + errorbars.")
BXCurrentGraphIC50Type$packStart(LBLCurrentGraphIC50Type, expand = FALSE, fill = FALSE)
BXCurrentGraphIC50Type$packStart(btnCurrentGraphIC50TypeNone, expand = FALSE, fill = FALSE)
BXCurrentGraphIC50Type$packStart(btnCurrentGraphIC50TypeObs, expand = FALSE, fill = FALSE)
BXCurrentGraphIC50Type$packStart(btnCurrentGraphIC50TypeAll, expand = FALSE, fill = FALSE)
BXCurrentGraphIC50Type$packStart(btnCurrentGraphIC50TypeAv, expand = FALSE, fill = FALSE)
BXCurrentGraphIC50Type$packStart(btnCurrentGraphIC50TypeBars, expand = FALSE, fill = FALSE)

BXCurrentGraphIC50["visible"] <- FALSE

####
#### Miniatur Frame
###################

FRMiniaturRaw <- gtkFrame("Raw data")
FRMiniaturRaw$setBorderWidth(2)
FRMiniaturMedium <- gtkFrame("Normalisation data")
FRMiniaturMedium$setBorderWidth(2)
FRMiniaturIC50 <- gtkFrame("IC50 data")
FRMiniaturIC50$setBorderWidth(2)
BXMiniatur$packStart(FRMiniaturRaw, expand = TRUE, fill = TRUE)
BXMiniaturRaw <- gtkVBox(FALSE, 5)
FRMiniaturRaw$add(BXMiniaturRaw)
BXMiniaturMedium <- gtkVBox(FALSE, 5)
FRMiniaturMedium$add(BXMiniaturMedium)
BXMiniaturIC50 <- gtkVBox(FALSE, 5)
FRMiniaturIC50$add(BXMiniaturIC50)

## Buttons:
btnRawShow <- gtkButton("Raw data")
btnRawOrigShow <- gtkButton("- Before formatting")
btnRawSmShow <- gtkButton("- Smoothed")
btnRawSlopeShow <- gtkButton("- Slope")
btnRawConsShow <- gtkButton("- Consumption")
btnRawAvShow <- gtkButton("- Average")
btnRawAvSmShow <- gtkButton("- Smoothed average")
btnRawAvSlopeShow <- gtkButton("- Average slope")
btnRawAvConsShow <- gtkButton("- Average consumption")
BXMiniaturRaw$packStart(btnRawShow, expand = TRUE, fill = TRUE)
BXMiniaturRaw$packStart(btnRawOrigShow, expand = TRUE, fill = TRUE)
BXMiniaturRaw$packStart(btnRawSmShow, expand = TRUE, fill = TRUE)
BXMiniaturRaw$packStart(btnRawSlopeShow, expand = TRUE, fill = TRUE)
BXMiniaturRaw$packStart(btnRawConsShow, expand = TRUE, fill = TRUE)
BXMiniaturRaw$packStart(btnRawAvShow, expand = TRUE, fill = TRUE)
BXMiniaturRaw$packStart(btnRawAvSmShow, expand = TRUE, fill = TRUE)
BXMiniaturRaw$packStart(btnRawAvSlopeShow, expand = TRUE, fill = TRUE)
BXMiniaturRaw$packStart(btnRawAvConsShow, expand = TRUE, fill = TRUE)
btnMediumShow <- gtkButton("Normalisation data")
btnMediumOrigShow <- gtkButton("- Before formatting")
btnMediumSmShow <- gtkButton("- Smoothed")
btnMediumSlopeShow <- gtkButton("- Slope")
btnMediumConsShow <- gtkButton("- Consumption")
btnMediumAvShow <- gtkButton("- Average")
btnMediumAvSmShow <- gtkButton("- Smoothed average")
btnMediumAvSlopeShow <- gtkButton("- Average slope")
btnMediumAvConsShow <- gtkButton("- Average consumption")
BXMiniaturMedium$packStart(btnMediumShow, expand = TRUE, fill = TRUE)
BXMiniaturMedium$packStart(btnMediumOrigShow, expand = TRUE, fill = TRUE)
BXMiniaturMedium$packStart(btnMediumSmShow, expand = TRUE, fill = TRUE)
BXMiniaturMedium$packStart(btnMediumSlopeShow, expand = TRUE, fill = TRUE)
BXMiniaturMedium$packStart(btnMediumConsShow, expand = TRUE, fill = TRUE)
BXMiniaturMedium$packStart(btnMediumAvShow, expand = TRUE, fill = TRUE)
BXMiniaturMedium$packStart(btnMediumAvSmShow, expand = TRUE, fill = TRUE)
BXMiniaturMedium$packStart(btnMediumAvSlopeShow, expand = TRUE, fill = TRUE)
BXMiniaturMedium$packStart(btnMediumAvConsShow, expand = TRUE, fill = TRUE)
btnIC50TimeShow <- gtkButton("Timeresolved IC50")
btnIC50FitShow <- gtkButton("Sigmoidal fit")
BXMiniaturIC50$packStart(btnIC50TimeShow, expand = TRUE, fill = TRUE)
BXMiniaturIC50$packStart(btnIC50FitShow, expand = TRUE, fill = TRUE)

#########################################################################################
#### Graph output Interactive
#########################################################################################

####
#### Signal: Raw Miniatur clicked
#################################
gSignalConnect(btnRawShow, "clicked", after = TRUE, quote({
  LBLCurrentGraphData$setLabel("Raw data")
  CKBShowSd["visible"] <- FALSE
  CKBShowSd$setActive(is.active = FALSE)
  BXCurrentGraphIC50["visible"] <- FALSE
  if (class(Data_raw[1,1]) == "NULL") {
    BXCurrentGraph$getChildren()[[1]]$destroy()
    LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
    BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
  } else {
    FCheckboxConstruct(Data_raw)
    BXCurrentGraph$getChildren()[[1]]$destroy()
    FOpenCairo(LBLCurrentGraphData$getLabel())
    FPlotStandard(D = Data_raw, T = Template, subnumber = "raw")
    if (TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
  }
}))

####
#### Signal: Raw before formatting Miniatur clicked
###################################################
gSignalConnect(btnRawOrigShow, "clicked", after = TRUE, quote({
  LBLCurrentGraphData$setLabel("Unformatted raw data")
  CKBShowSd["visible"] <- FALSE
  CKBShowSd$setActive(is.active = FALSE)
  BXCurrentGraphIC50["visible"] <- FALSE
  if (class(Data_rawOrig[1,1]) == "NULL") {
    BXCurrentGraph$getChildren()[[1]]$destroy()
    LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
    BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
  } else {
    FCheckboxConstruct(Data_rawOrig)
    BXCurrentGraph$getChildren()[[1]]$destroy()
    FOpenCairo(LBLCurrentGraphData$getLabel())
    FPlotStandard(D = Data_rawOrig, T = Template, subnumber = "rawOrig")
    if (TEMPChecksums$Data_rawOrig[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
  }
}))

####
#### Signal: Smoothed raw Miniatur clicked
##########################################
gSignalConnect(btnRawSmShow, "clicked", after = TRUE, quote({
  LBLCurrentGraphData$setLabel("Raw data smoothed")
  CKBShowSd["visible"] <- FALSE
  CKBShowSd$setActive(is.active = FALSE)
  BXCurrentGraphIC50["visible"] <- FALSE
  if (class(Data_rawSm[1,1]) == "NULL") {
    BXCurrentGraph$getChildren()[[1]]$destroy()
    LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
    BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
  } else {
    FCheckboxConstruct(Data_rawSm)
    BXCurrentGraph$getChildren()[[1]]$destroy()
    FOpenCairo(LBLCurrentGraphData$getLabel())
    FPlotStandard(D = Data_rawSm, T = Template, subnumber = "rawSm")
    if (TEMPChecksums$Data_rawSm[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
  }
}))

####
#### Signal: Slope of raw Miniatur clicked
##########################################
gSignalConnect(btnRawSlopeShow, "clicked", after = TRUE, quote({
  LBLCurrentGraphData$setLabel("Raw data slope")
  CKBShowSd["visible"] <- TRUE
  if (class(Data_rawSlope[1,1]) == "NULL") {
    BXCurrentGraph$getChildren()[[1]]$destroy()
    LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
    BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
  } else {
    FCheckboxConstruct(Data_rawSlope)
    BXCurrentGraph$getChildren()[[1]]$destroy()
    FOpenCairo(LBLCurrentGraphData$getLabel())
    FPlotStandard(D = Data_rawSlope, DSd = Data_rawSlopeSd, T = Template, subnumber = "rawSlope")
    if (TEMPChecksums$Data_rawSlope[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
  }
}))

####
#### Signal: Consumption of raw Miniatur clicked
################################################
gSignalConnect(btnRawConsShow, "clicked", after = TRUE, quote({
  LBLCurrentGraphData$setLabel("Raw data consumption")
  CKBShowSd["visible"] <- TRUE
  if (class(Data_rawCons[1,1]) == "NULL") {
    BXCurrentGraph$getChildren()[[1]]$destroy()
    LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
    BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
  } else {
    FCheckboxConstruct(Data_rawCons)
    BXCurrentGraph$getChildren()[[1]]$destroy()
    FOpenCairo(LBLCurrentGraphData$getLabel())
    FPlotStandard(D = Data_rawCons, DSd = Data_rawConsSd, T = Template, subnumber = "rawCons", altYLabel = SETAnalysisOpt$ConsCharacters["axis"])
    if (TEMPChecksums$Data_rawCons[1] != TEMPChecksums$Data_rawSlope[2] | TEMPChecksums$Data_rawSlope[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
  }
}))

####
#### Signal: Raw Average Miniatur clicked
#########################################
gSignalConnect(btnRawAvShow, "clicked", after = TRUE, quote({
  LBLCurrentGraphData$setLabel("Average raw data")
  if (SETAnalysisOpt$raw[2] == TRUE & SETAnalysisOpt$SD == TRUE) CKBShowSd["visible"] <- TRUE
  else {
    CKBShowSd["visible"] <- FALSE
    CKBShowSd$setActive(is.active = FALSE)
  }
  BXCurrentGraphIC50["visible"] <- FALSE
  if (class(Data_rawAv[1,1]) == "NULL") {
    BXCurrentGraph$getChildren()[[1]]$destroy()
    LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
    BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
  } else {
    FTemplateMean()
    FCheckboxConstruct(Data_rawAv)
    BXCurrentGraph$getChildren()[[1]]$destroy()
    FOpenCairo(LBLCurrentGraphData$getLabel())
    FPlotStandard(D = Data_rawAv, DSd = Data_rawSd, T = TemplateAverage, subnumber = "rawAv")
    if (TEMPChecksums$Data_rawAv[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
  }
}))

####
#### Signal: Smoothed raw Average Miniatur clicked
##################################################
gSignalConnect(btnRawAvSmShow, "clicked", after = TRUE, quote({
  LBLCurrentGraphData$setLabel("Average raw data smoothed")
  CKBShowSd["visible"] <- FALSE
  CKBShowSd$setActive(is.active = FALSE)
  BXCurrentGraphIC50["visible"] <- FALSE
  if (class(Data_rawAvSm[1,1]) == "NULL") {
    BXCurrentGraph$getChildren()[[1]]$destroy()
    LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
    BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
  } else {
    FTemplateMean()
    FCheckboxConstruct(Data_rawAvSm)
    BXCurrentGraph$getChildren()[[1]]$destroy()
    FOpenCairo(LBLCurrentGraphData$getLabel())
    FPlotStandard(D = Data_rawAvSm, T = TemplateAverage, subnumber = "rawAvSm")
    if (TEMPChecksums$Data_rawAvSm[1] != TEMPChecksums$Data_rawAv[2] | TEMPChecksums$Data_rawAv[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
  }
}))

####
#### Signal: Slope of average raw Miniatur clicked
##################################################
gSignalConnect(btnRawAvSlopeShow, "clicked", after = TRUE, quote({
  LBLCurrentGraphData$setLabel("Average raw data slope")
  CKBShowSd["visible"] <- TRUE
  if (class(Data_rawAvSlope[1,1]) == "NULL") {
    BXCurrentGraph$getChildren()[[1]]$destroy()
    LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
    BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
  } else {
    FCheckboxConstruct(Data_rawAvSlope)
    BXCurrentGraph$getChildren()[[1]]$destroy()
    FOpenCairo(LBLCurrentGraphData$getLabel())
    FPlotStandard(D = Data_rawAvSlope, DSd = Data_rawAvSlopeSd, T = TemplateAverage, subnumber = "rawAvSlope")
    if (TEMPChecksums$Data_rawAvSlope[1] != TEMPChecksums$Data_rawAv[2] | TEMPChecksums$Data_rawAv[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
  }
}))

####
#### Signal: Consumption of average raw Miniatur clicked
########################################################
gSignalConnect(btnRawAvConsShow, "clicked", after = TRUE, quote({
  LBLCurrentGraphData$setLabel("Average raw data consumption")
  CKBShowSd["visible"] <- TRUE
  if (class(Data_rawAvCons[1,1]) == "NULL") {
    BXCurrentGraph$getChildren()[[1]]$destroy()
    LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
    BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
  } else {
    FCheckboxConstruct(Data_rawAvCons)
    BXCurrentGraph$getChildren()[[1]]$destroy()
    FOpenCairo(LBLCurrentGraphData$getLabel())
    FPlotStandard(D = Data_rawAvCons, DSd = Data_rawAvConsSd, T = TemplateAverage, subnumber = "rawAvCons", altYLabel = SETAnalysisOpt$ConsCharacters["axis"])
    if (TEMPChecksums$Data_rawAvCons[1] != TEMPChecksums$Data_rawAvSlope[2] | TEMPChecksums$Data_rawAvSlope[1] != TEMPChecksums$Data_rawAv[2] | TEMPChecksums$Data_rawAv[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
  }
}))

####
#### Signal: Medium Miniatur clicked
####################################
gSignalConnect(btnMediumShow, "clicked", after = TRUE, quote({
  LBLCurrentGraphData$setLabel("Medium data")
  CKBShowSd["visible"] <- FALSE
  CKBShowSd$setActive(is.active = FALSE)
  BXCurrentGraphIC50["visible"] <- FALSE
  if (class(Data_medium[1,1]) == "NULL") {
    BXCurrentGraph$getChildren()[[1]]$destroy()
    LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
    BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
  } else {
    FCheckboxConstruct(Data_medium)
    BXCurrentGraph$getChildren()[[1]]$destroy()
    FOpenCairo(LBLCurrentGraphData$getLabel())
    FPlotStandard(D = Data_medium, T = Template, subnumber = "medium")
    if (SETAnalysisOpt$oxoDish[1] == TRUE) {
      if (TEMPChecksums$Data_medium[1] != TEMPChecksums$Data_oxoDish[2] | TEMPChecksums$Data_oxoDish[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
    } else {
      if (TEMPChecksums$Data_medium[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
    }
  }
}))

####
#### Signal: Unformatted medium Miniatur clicked
################################################
gSignalConnect(btnMediumOrigShow, "clicked", after = TRUE, quote({
  LBLCurrentGraphData$setLabel("Unformatted medium data")
  CKBShowSd["visible"] <- FALSE
  CKBShowSd$setActive(is.active = FALSE)
  BXCurrentGraphIC50["visible"] <- FALSE
  if (class(Data_mediumOrig[1,1]) == "NULL") {
    BXCurrentGraph$getChildren()[[1]]$destroy()
    LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
    BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
  } else {
    FCheckboxConstruct(Data_mediumOrig)
    BXCurrentGraph$getChildren()[[1]]$destroy()
    FOpenCairo(LBLCurrentGraphData$getLabel())
    FPlotStandard(D = Data_mediumOrig, T = Template, subnumber = "mediumOrig")
    if (SETAnalysisOpt$oxoDish[1] == TRUE) {
      if (TEMPChecksums$Data_mediumOrig[1] != TEMPChecksums$Data_oxoDish[2] | TEMPChecksums$Data_oxoDish[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
    } else {
      if (TEMPChecksums$Data_mediumOrig[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
    }
  }
}))

####
#### Signal: Smoothed medium Miniatur clicked
#############################################
gSignalConnect(btnMediumSmShow, "clicked", after = TRUE, quote({
  LBLCurrentGraphData$setLabel("Medium data smoothed")
  CKBShowSd["visible"] <- FALSE
  CKBShowSd$setActive(is.active = FALSE)
  BXCurrentGraphIC50["visible"] <- FALSE
  if (class(Data_mediumSm[1,1]) == "NULL") {
    BXCurrentGraph$getChildren()[[1]]$destroy()
    LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
    BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
  } else {
    FCheckboxConstruct(Data_mediumSm)
    BXCurrentGraph$getChildren()[[1]]$destroy()
    FOpenCairo(LBLCurrentGraphData$getLabel())
    FPlotStandard(D = Data_mediumSm, T = Template, subnumber = "mediumSm")
    if (TEMPChecksums$Data_mediumSm[1] != TEMPChecksums$Data_medium[2]) FNotificationDataUpdate()
    if (SETAnalysisOpt$oxoDish[1] == TRUE) {
      if (TEMPChecksums$Data_mediumSm[1] != TEMPChecksums$Data_medium[2] | TEMPChecksums$Data_medium[1] != TEMPChecksums$Data_oxoDish[2] | TEMPChecksums$Data_oxoDish[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
    } else {
      if (TEMPChecksums$Data_mediumSm[1] != TEMPChecksums$Data_medium[2] | TEMPChecksums$Data_medium[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
    }
  }
}))

####
#### Signal: Slope of medium Miniatur clicked
#############################################
gSignalConnect(btnMediumSlopeShow, "clicked", after = TRUE, quote({
  LBLCurrentGraphData$setLabel("Medium data slope")
  CKBShowSd["visible"] <- TRUE
  if (class(Data_mediumSlope[1,1]) == "NULL") {
    BXCurrentGraph$getChildren()[[1]]$destroy()
    LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
    BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
  } else {
    FCheckboxConstruct(Data_mediumSlope)
    BXCurrentGraph$getChildren()[[1]]$destroy()
    FOpenCairo(LBLCurrentGraphData$getLabel())
    FPlotStandard(D = Data_mediumSlope, DSd = Data_mediumSlopeSd, T = Template, subnumber = "mediumSlope")
    if (SETAnalysisOpt$oxoDish[1] == TRUE) {
      if (TEMPChecksums$Data_mediumSlope[1] != TEMPChecksums$Data_medium[2] | TEMPChecksums$Data_medium[1] != TEMPChecksums$Data_oxoDish[2] | TEMPChecksums$Data_oxoDish[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
    } else {
      if (TEMPChecksums$Data_mediumSlope[1] != TEMPChecksums$Data_medium[2] | TEMPChecksums$Data_medium[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
    }
  }
}))

####
#### Signal: Consumption of medium Miniatur clicked
###################################################
gSignalConnect(btnMediumConsShow, "clicked", after = TRUE, quote({
  LBLCurrentGraphData$setLabel("Medium data consumption")
  CKBShowSd["visible"] <- TRUE
  if (class(Data_mediumCons[1,1]) == "NULL") {
    BXCurrentGraph$getChildren()[[1]]$destroy()
    LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
    BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
  } else {
    FCheckboxConstruct(Data_mediumCons)
    BXCurrentGraph$getChildren()[[1]]$destroy()
    FOpenCairo(LBLCurrentGraphData$getLabel())
    FPlotStandard(D = Data_mediumCons, DSd = Data_mediumConsSd, T = Template, subnumber = "mediumCons", altYLabel = SETAnalysisOpt$ConsCharacters["axis"])
    if (SETAnalysisOpt$oxoDish[1] == TRUE) {
      if (TEMPChecksums$Data_mediumCons[1] != TEMPChecksums$Data_mediumSlope[2] | TEMPChecksums$Data_mediumSlope[1] != TEMPChecksums$Data_medium[2] | TEMPChecksums$Data_medium[1] != TEMPChecksums$Data_oxoDish[2] | TEMPChecksums$Data_oxoDish[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
    } else {
      if (TEMPChecksums$Data_mediumCons[1] != TEMPChecksums$Data_mediumSlope[2] | TEMPChecksums$Data_mediumSlope[1] != TEMPChecksums$Data_medium[2] | TEMPChecksums$Data_medium[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
    }
  }
}))

####
#### Signal: Medium Average Miniatur clicked
############################################
gSignalConnect(btnMediumAvShow, "clicked", after = TRUE, quote({
  LBLCurrentGraphData$setLabel("Average medium data")
  if (SETAnalysisOpt$medium[2] == TRUE & SETAnalysisOpt$SD == TRUE) CKBShowSd["visible"] <- TRUE
  else {
    CKBShowSd["visible"] <- FALSE
    CKBShowSd$setActive(is.active = FALSE)
  }
  BXCurrentGraphIC50["visible"] <- FALSE
  if (class(Data_mediumAv[1,1]) == "NULL") {
    BXCurrentGraph$getChildren()[[1]]$destroy()
    LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
    BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
  } else {
    FTemplateMean()
    FCheckboxConstruct(Data_mediumAv)
    BXCurrentGraph$getChildren()[[1]]$destroy()
    FOpenCairo(LBLCurrentGraphData$getLabel())
    FPlotStandard(D = Data_mediumAv, DSd = Data_mediumSd, T = TemplateAverage, subnumber = "mediumAv")
    if (SETAnalysisOpt$oxoDish[1] == TRUE) {
      if (TEMPChecksums$Data_mediumAv[1] != TEMPChecksums$Data_medium[2] | TEMPChecksums$Data_medium[1] != TEMPChecksums$Data_oxoDish[2] | TEMPChecksums$Data_oxoDish[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
    } else {
      if (TEMPChecksums$Data_mediumAv[1] != TEMPChecksums$Data_medium[2] | TEMPChecksums$Data_medium[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
    }
  }
}))

####
#### Signal: Smoothed medium Average Miniatur clicked
#####################################################
gSignalConnect(btnMediumAvSmShow, "clicked", after = TRUE, quote({
  LBLCurrentGraphData$setLabel("Average medium data smoothed")
  CKBShowSd["visible"] <- FALSE
  CKBShowSd$setActive(is.active = FALSE)
  BXCurrentGraphIC50["visible"] <- FALSE
  if (class(Data_mediumAvSm[1,1]) == "NULL") {
    BXCurrentGraph$getChildren()[[1]]$destroy()
    LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
    BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
  } else {
    FTemplateMean()
    FCheckboxConstruct(Data_mediumAvSm)
    BXCurrentGraph$getChildren()[[1]]$destroy()
    FOpenCairo(LBLCurrentGraphData$getLabel())
    FPlotStandard(D = Data_mediumAvSm, T = TemplateAverage, subnumber = "mediumAvSm")
    if (SETAnalysisOpt$oxoDish[1] == TRUE) {
      if (TEMPChecksums$Data_mediumAvSm[1] != TEMPChecksums$Data_mediumAv[2] | TEMPChecksums$Data_mediumAv[1] != TEMPChecksums$Data_medium[2] | TEMPChecksums$Data_medium[1] != TEMPChecksums$Data_oxoDish[2] | TEMPChecksums$Data_oxoDish[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
    } else {
      if (TEMPChecksums$Data_mediumAvSm[1] != TEMPChecksums$Data_mediumAv[2] | TEMPChecksums$Data_mediumAv[1] != TEMPChecksums$Data_medium[2] | TEMPChecksums$Data_medium[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
    }
  }
}))

####
#### Signal: Slope of average medium Miniatur clicked
#####################################################
gSignalConnect(btnMediumAvSlopeShow, "clicked", after = TRUE, quote({
  LBLCurrentGraphData$setLabel("Average normalisation data slope")
  CKBShowSd["visible"] <- TRUE
  if (class(Data_mediumAvSlope[1,1]) == "NULL") {
    BXCurrentGraph$getChildren()[[1]]$destroy()
    LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
    BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
  } else {
    FCheckboxConstruct(Data_mediumAvSlope)
    BXCurrentGraph$getChildren()[[1]]$destroy()
    FOpenCairo(LBLCurrentGraphData$getLabel())
    FPlotStandard(D = Data_mediumAvSlope, DSd = Data_mediumAvSlopeSd, T = TemplateAverage, subnumber = "mediumAvSlope")
    if (SETAnalysisOpt$oxoDish[1] == TRUE) {
      if (TEMPChecksums$Data_mediumAvSlope[1] != TEMPChecksums$Data_mediumAv[2] | TEMPChecksums$Data_mediumAv[1] != TEMPChecksums$Data_medium[2] | TEMPChecksums$Data_medium[1] != TEMPChecksums$Data_oxoDish[2] | TEMPChecksums$Data_oxoDish[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
    } else {
      if (TEMPChecksums$Data_mediumAvSlope[1] != TEMPChecksums$Data_mediumAv[2] | TEMPChecksums$Data_mediumAv[1] != TEMPChecksums$Data_medium[2] | TEMPChecksums$Data_medium[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
    }
  }
}))

####
#### Signal: Consumption of average medium Miniatur clicked
###########################################################
gSignalConnect(btnMediumAvConsShow, "clicked", after = TRUE, quote({
  LBLCurrentGraphData$setLabel("Average normalisation data consumption")
  CKBShowSd["visible"] <- TRUE
  if (class(Data_mediumAvCons[1,1]) == "NULL") {
    BXCurrentGraph$getChildren()[[1]]$destroy()
    LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
    BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
  } else {
    FCheckboxConstruct(Data_mediumAvCons)
    BXCurrentGraph$getChildren()[[1]]$destroy()
    FOpenCairo(LBLCurrentGraphData$getLabel())
    FPlotStandard(D = Data_mediumAvCons, DSd = Data_mediumAvConsSd, T = TemplateAverage, subnumber = "mediumAvCons", altYLabel = SETAnalysisOpt$ConsCharacters["axis"])
    if (SETAnalysisOpt$oxoDish[1] == TRUE) {
      if (TEMPChecksums$Data_mediumAvCons[1] != TEMPChecksums$Data_mediumAvSlope[2] | TEMPChecksums$Data_mediumAvSlope[1] != TEMPChecksums$Data_mediumAv[2] | TEMPChecksums$Data_mediumAv[1] != TEMPChecksums$Data_medium[2] | TEMPChecksums$Data_medium[1] != TEMPChecksums$Data_oxoDish[2] | TEMPChecksums$Data_oxoDish[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
    } else {
      if (TEMPChecksums$Data_mediumAvCons[1] != TEMPChecksums$Data_mediumAvSlope[2] | TEMPChecksums$Data_mediumAvSlope[1] != TEMPChecksums$Data_mediumAv[2] | TEMPChecksums$Data_mediumAv[1] != TEMPChecksums$Data_medium[2] | TEMPChecksums$Data_medium[1] != TEMPChecksums$Data_raw[2] | TEMPChecksums$Data_raw[1] != TEMPChecksums$Data_input) FNotificationDataUpdate()
    }
  }
}))

####
#### Signal: Timeresolved IC50 clicked
######################################
gSignalConnect(btnIC50TimeShow, "clicked", quote({
  LBLCurrentGraphData$setLabel("Timeresolved IC50 data")
  CKBShowSd["visible"] <- TRUE
  BXCurrentGraphIC50["visible"] <- FALSE
  if (class(Data_IC50[1,1]) == "NULL") {
    BXCurrentGraph$getChildren()[[1]]$destroy()
    LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
    BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
  } else {
    ## Clear list of checkboxes
    Checkboxes <- list()
    removeCheckboxes <- BXLineSel$getChildren()
    if (length(removeCheckboxes) != 0) {
      for (i in 1: length(removeCheckboxes)) BXLineSel$remove(removeCheckboxes[[i]])
    }
    BXCurrentGraph$getChildren()[[1]]$destroy()
    FOpenCairo(LBLCurrentGraphData$getLabel())
    FPlotIC50Time(Data_IC50)
    if (TEMPChecksums$Data_IC50[1] != TEMPChecksums[[SETAnalysisOpt$IC50]][2]) FNotificationDataUpdate()
  }
}))

####
#### Signal: Sigmoidal fit IC50 clicked
#######################################
gSignalConnect(btnIC50FitShow, "clicked", quote({
  LBLCurrentGraphData$setLabel("IC50 fitting data")
  CKBShowSd["visible"] <- FALSE
  CKBShowSd$setActive(is.active = FALSE)
  BXCurrentGraphIC50["visible"] <- TRUE
  if (length(Data_IC50Models) == 0) {
    BXCurrentGraph$getChildren()[[1]]$destroy()
    LBLCurrentGraph <- gtkLabel("Please run the analysis first!")
    BXCurrentGraph$packStart(LBLCurrentGraph, expand = TRUE, fill = TRUE)
  } else {
    TEMPNames <- rbind(c(-1, Data_IC50[,1]), c(-1, Data_IC50[,2]))
    names(TEMPNames) <- c("X", as.character(Data_IC50[,1]))
    FCheckboxConstruct(TEMPNames)
    BXCurrentGraph$getChildren()[[1]]$destroy()
    FOpenCairo(LBLCurrentGraphData$getLabel())
    FPlotIC50Fit(Data_IC50Models)
    if (TEMPChecksums$Data_IC50Models[1] != TEMPChecksums[[SETAnalysisOpt$IC50]][2]) FNotificationDataUpdate()
  }
}))

####
#### Signal: Select all
#######################
gSignalConnect(btnLineSelectAll, "clicked", quote({
  for (i in 1:length(Checkboxes)) {
    Checkboxes[[i]]$setActive(is.active = TRUE)
  }
}))

####
#### Signal: Select none
########################
gSignalConnect(btnLineSelectNone, "clicked", quote({
  for (i in 1:length(Checkboxes)) {
    Checkboxes[[i]]$setActive(is.active = FALSE)
  }
}))

####
#### Signal: Standard deviation Show
####################################
gSignalConnect(CKBShowSd, "toggled", after = TRUE, quote(FRefreshGraph()))

####
#### Signal: Slider Select
##########################
## The slider has to be redefined, whenever the selection of the parameter is changed.
## When the selection is changed, the old slider is destroyed and newly defined according
## to the selection. The old setting will be restored and the very simple signal
## handler is also reimplemented every single time. This includes system sleeping times to
## allow for smooth sliding. (Otherwise the graph would update for every value, that was passed.)
SCBCex <- gtkHScale(min = 0, max = 1, step = 1)
gSignalConnect(COMScalebar, "changed", after = TRUE, quote({
  # Pos 0 is pointsize
  if (COMScalebar$getActive() == "0") {
    if (exists("SCBCex") == TRUE) SCBCex$destroy()
    SCBCex <- gtkHScale(min = 5, max = 25, step = .5)
    SCBCex$setValue(SETGraphOutput$Scalebar["pt"])
    BXCurrentGraphSettings$packStart(SCBCex, expand = TRUE, fill = TRUE)
    #### Signal: Slider Change
    ##########################
    gSignalConnect(SCBCex, "value-changed", after = TRUE, quote({
      Sys.sleep(.3)
      SETGraphOutput$Scalebar["pt"] <- SCBCex$getValue()
      Sys.sleep(.1)
      FRefreshGraph()
    }))
    # Pos 1 is number of columns in the legend
  } else if (COMScalebar$getActive() == "1") {
    if (exists("SCBCex") == TRUE) SCBCex$destroy()
    SCBCex <- gtkHScale(min = 1, max = 10, step = 1)
    SCBCex$setValue(SETGraphOutput$Scalebar["columns"])
    BXCurrentGraphSettings$packStart(SCBCex, expand = TRUE, fill = TRUE)
    #### Signal: Slider Change
    ##########################
    gSignalConnect(SCBCex, "value-changed", after = TRUE, quote({
      Sys.sleep(.3)
      SETGraphOutput$Scalebar["columns"] <- SCBCex$getValue()
      Sys.sleep(.1)
      FRefreshGraph()
    }))
    # Pos 2 is the position of the legend selected by drop down menu
  } else if (COMScalebar$getActive() == "2") {
    if (exists("SCBCex") == TRUE) SCBCex$destroy()
    SCBCex <- gtkComboBoxNewText()
    SCBCex$appendText("no legend")                     # 0
    SCBCex$appendText("below the plot area")           # 1
    SCBCex$appendText("to the right of the plot area") # 2
    SCBCex$appendText("top left")                      # 3
    SCBCex$appendText("top middle")                    # 4
    SCBCex$appendText("top right")                     # 5
    SCBCex$appendText("middle right")                  # 6
    SCBCex$appendText("bottom right")                  # 7
    SCBCex$appendText("bottom middle")                 # 8
    SCBCex$appendText("bottom left")                   # 9
    SCBCex$appendText("middle left")                   # 10
    SCBCex$setActive(SETGraphOutput$Scalebar["position"])
    BXCurrentGraphSettings$packStart(SCBCex, expand = TRUE, fill = TRUE)
    #### Signal: Selection Change
    #############################
    gSignalConnect(SCBCex, "changed", after = TRUE, quote({
      SETGraphOutput$Scalebar["position"] <- SCBCex$getActive()
      Sys.sleep(.1)
      FRefreshGraph()
    }))
    # Pos 3 is line width
  } else if (COMScalebar$getActive() == "3") {
    if (exists("SCBCex") == TRUE) SCBCex$destroy()
    SCBCex <- gtkHScale(min = 0.5, max = 4, step = 0.5)
    SCBCex$setValue(SETGraphOutput$Scalebar["lwd"])
    BXCurrentGraphSettings$packStart(SCBCex, expand = TRUE, fill = TRUE)
    #### Signal: Slider Change
    ##########################
    gSignalConnect(SCBCex, "value-changed", after = TRUE, quote({
      Sys.sleep(.3)
      SETGraphOutput$Scalebar["lwd"] <- SCBCex$getValue()
      Sys.sleep(.1)
      FRefreshGraph()
    }))
    # Pos 4 is grid color intensity
  } else if (COMScalebar$getActive() == "4") {
    if (exists("SCBCex") == TRUE) SCBCex$destroy()
    SCBCex <- gtkHScale(min = 0, max = 100, step = 1)
    SCBCex$setValue(SETGraphOutput$Scalebar["grid"])
    BXCurrentGraphSettings$packStart(SCBCex, expand = TRUE, fill = TRUE)
    #### Signal: Slider Change
    ##########################
    gSignalConnect(SCBCex, "value-changed", after = TRUE, quote({
      Sys.sleep(.3)
      SETGraphOutput$Scalebar["grid"] <- SCBCex$getValue()
      Sys.sleep(.1)
      FRefreshGraph()
    }))
    # Pos 5 is error intensity
  } else if (COMScalebar$getActive() == "5") {
    if (exists("SCBCex") == TRUE) SCBCex$destroy()
    SCBCex <- gtkHScale(min = 0, max = 100, step = 1)
    SCBCex$setValue(SETGraphOutput$Scalebar["error"])
    BXCurrentGraphSettings$packStart(SCBCex, expand = TRUE, fill = TRUE)
    #### Signal: Slider Change
    ##########################
    gSignalConnect(SCBCex, "value-changed", after = TRUE, quote({
      Sys.sleep(.3)
      SETGraphOutput$Scalebar["error"] <- SCBCex$getValue()
      Sys.sleep(.1)
      FRefreshGraph()
    }))
    # Pos 6 is whitespace
  } else if (COMScalebar$getActive() == "6") {
    if (exists("SCBCex") == TRUE) SCBCex$destroy()
    SCBCex <- gtkHScale(min = 0, max = 1, step = 0.05)
    SCBCex$setValue(SETGraphOutput$Scalebar["whitespace"])
    BXCurrentGraphSettings$packStart(SCBCex, expand = TRUE, fill = TRUE)
    #### Signal: Slider Change
    ##########################
    gSignalConnect(SCBCex, "value-changed", after = TRUE, quote({
      Sys.sleep(.3)
      SETGraphOutput$Scalebar["whitespace"] <- SCBCex$getValue()
      Sys.sleep(.1)
      FRefreshGraph()
    }))
  }
}))

####
#### Signal: IC50 Differentiation Type
######################################
gSignalConnect(btnCurrentGraphIC50DiffCol, "toggled", after = TRUE, quote({
  if (btnCurrentGraphIC50DiffCol$getActive() == TRUE) SETGraphOutput$IC50["diff"] <- "colour"
  else if (btnCurrentGraphIC50DiffLty$getActive() == TRUE) SETGraphOutput$IC50["diff"] <- "lty"
  else if (btnCurrentGraphIC50DiffNone$getActive() == TRUE) SETGraphOutput$IC50["diff"] <- "none"
  gSignalEmit(btnIC50FitShow, "clicked")
  #print(SETGraphOutput$IC50)
}))
gSignalConnect(btnCurrentGraphIC50DiffLty, "toggled", after = TRUE, quote({
  if (btnCurrentGraphIC50DiffCol$getActive() == TRUE) SETGraphOutput$IC50["diff"] <- "colour"
  else if (btnCurrentGraphIC50DiffLty$getActive() == TRUE) SETGraphOutput$IC50["diff"] <- "lty"
  else if (btnCurrentGraphIC50DiffNone$getActive() == TRUE) SETGraphOutput$IC50["diff"] <- "none"
  gSignalEmit(btnIC50FitShow, "clicked")
  #print(SETGraphOutput$IC50)
}))

####
#### Signal: IC50 Display Type
##############################
####
#### Function: Get Type setting
###############################
FButtonsIC50Type <- function() {
  if (btnCurrentGraphIC50TypeAv$getActive() == TRUE) SETGraphOutput$IC50["type"] <<- "average"
  else if (btnCurrentGraphIC50TypeNone$getActive() == TRUE) SETGraphOutput$IC50["type"] <<- "none"
  else if (btnCurrentGraphIC50TypeBars$getActive() == TRUE) SETGraphOutput$IC50["type"] <<- "bars"
  else if (btnCurrentGraphIC50TypeAll$getActive() == TRUE) SETGraphOutput$IC50["type"] <<- "all"
  else if (btnCurrentGraphIC50TypeObs$getActive() == TRUE) SETGraphOutput$IC50["type"] <<- "obs"
  gSignalEmit(btnIC50FitShow, "clicked")
  #print(SETGraphOutput$IC50)
}

gSignalConnect(btnCurrentGraphIC50TypeAv, "toggled", quote(FButtonsIC50Type()))
gSignalConnect(btnCurrentGraphIC50TypeNone, "toggled", quote(FButtonsIC50Type()))
gSignalConnect(btnCurrentGraphIC50TypeObs, "toggled", quote(FButtonsIC50Type()))
gSignalConnect(btnCurrentGraphIC50TypeAll, "toggled", quote(FButtonsIC50Type()))

#########################################################################################
#### Graph output execute
#########################################################################################

####
#### Function: Acquire Settings:
################################
FLinesGetSettings <- function() {
  SETGraphOutput[[LBLCurrentGraphData$getLabel()]] <- c()
  for (i in 1:length(Checkboxes)) {
    if (gtkToggleButtonGetActive(Checkboxes[[i]]) == TRUE) {
      SETGraphOutput[[LBLCurrentGraphData$getLabel()]][i] <<- TRUE
    } else {
      SETGraphOutput[[LBLCurrentGraphData$getLabel()]][i] <<- FALSE
    }
  }
}

####
#### Signal: Refresh Lines
##########################
gSignalConnect(btnCurrentRefreshLines, "clicked", quote({
  if (LBLCurrentGraphData$getLabel() != "Timeresolved IC50 data") FLinesGetSettings()
  FRefreshGraph()
}))

####
#### Signal: Refresh Settings:
##############################
gSignalConnect(btnCurrentRefreshSet, "clicked", quote({
  if (LBLCurrentGraphData$getLabel() != "Timeresolved IC50 data") FLinesGetSettings()
  FCheckGraphOpt(CheckInputGraphOpt)
  gSignalEmit(ENTIC50Axis, "activate")
  FRefreshGraph()
}))

####
#### Signal: Save displayed Graph
#################################
gSignalConnect(btnCurrentExport, "clicked", quote({
  POPExportGraph <- gtkMessageDialog(mainApplication, "destroy-with-parent", type = "question", buttons = "none", paste("Please enter a filename and the size in inches. \nThe graph will be saved in your current project folder:\n\n", paste(getwd(), SETDataOutput$folder, sep="/"), sep=""))
  POPExportGraph$addButton("Continue", 1)
  POPExportGraph$addButton("Cancel", 2)
  LBLExportFiletypes <- gtkLabel("The available formats are pdf, ps, svg and png.")
  ENTExportGraph <- gtkEntry()
  ENTExportGraph$setSizeRequest(-1, 20)
  ENTExportGraph$setText("Graph.png")
  BXExportSize <- gtkHBox(FALSE, 5)
  ENTExportWidth <- gtkEntry()
  ENTExportWidth$setSizeRequest(40, 20)
  ENTExportWidth$setText(10)
  LBLX <- gtkLabel("X")
  ENTExportHeight <- gtkEntry()
  ENTExportHeight$setSizeRequest(40, 20)
  ENTExportHeight$setText(7)
  BXExportSize$packStart(ENTExportWidth, expand = TRUE, fill = TRUE)
  BXExportSize$packStart(LBLX, expand = FALSE, fill = FALSE)
  BXExportSize$packStart(ENTExportHeight, expand = TRUE, fill = TRUE)
  POPExportGraph[["vbox"]]$add(LBLExportFiletypes)
  POPExportGraph[["vbox"]]$add(ENTExportGraph)
  POPExportGraph[["vbox"]]$add(BXExportSize)
  response <- POPExportGraph$run()
  fileexists <- FCheckFileExistance(paste(SETDataOutput$folder, ENTExportGraph$getText(), sep="/"))
  if (response == 1 & fileexists == TRUE) {
    if (LBLCurrentGraphData$getLabel() != "Timeresolved IC50 data") FLinesGetSettings()
    FSaveCairo(ENTExportGraph$getText(), ENTExportWidth$getText(), ENTExportHeight$getText(), SETGraphOutput$Scalebar[1])
    if (LBLCurrentGraphData$getLabel() == "Raw data") FPlotStandard(D = Data_raw, T = Template, subnumber = "raw")
    else if (LBLCurrentGraphData$getLabel() == "Unformatted raw data") FPlotStandard(D = Data_rawOrig, T = Template, subnumber = "rawOrig")
    else if (LBLCurrentGraphData$getLabel() == "Raw data smoothed") FPlotStandard(D = Data_rawSm, T = Template, subnumber = "rawSm")
    else if (LBLCurrentGraphData$getLabel() == "Raw data slope") FPlotStandard(D = Data_rawSlope, DSd = Data_rawSlopeSd, T = Template, subnumber = "rawSlope")
    else if (LBLCurrentGraphData$getLabel() == "Raw data consumption") FPlotStandard(D = Data_rawCons, DSd = Data_rawConsSd, T = Template, subnumber = "rawCons", altYLabel = SETAnalysisOpt$ConsCharacters["axis"])
    else if (LBLCurrentGraphData$getLabel() == "Average raw data") FPlotStandard(D = Data_rawAv, DSd = Data_rawSd, T = TemplateAverage, subnumber = "rawAv")
    else if (LBLCurrentGraphData$getLabel() == "Average raw data smoothed") FPlotStandard(D = Data_rawAvSm, T = TemplateAverage, subnumber = "rawAvSm")
    else if (LBLCurrentGraphData$getLabel() == "Average raw data slope") FPlotStandard(D = Data_rawAvSlope, DSd = Data_rawAvSlopeSd, T = TemplateAverage, subnumber = "rawAvSlope")
    else if (LBLCurrentGraphData$getLabel() == "Average raw data consumption") FPlotStandard(D = Data_rawAvCons, DSd = Data_rawAvConsSd, T = TemplateAverage, subnumber = "rawAvCons", altYLabel = SETAnalysisOpt$ConsCharacters["axis"])
    else if (LBLCurrentGraphData$getLabel() == "Sensor corrected data") FPlotStandard(D = Data_oxoDish, T = Template, subnumber = "oxoDish")
    else if (LBLCurrentGraphData$getLabel() == "Unformatted sensor corrected data") FPlotStandard(D = Data_oxoDishOrig, T = Template, subnumber = "oxoDishOrig")
    else if (LBLCurrentGraphData$getLabel() == "Sensor corrected data smoothed") FPlotStandard(D = Data_oxoDishSm, T = Template, subnumber = "oxoDishSm")
    else if (LBLCurrentGraphData$getLabel() == "Sensor corrected data slope") FPlotStandard(D = Data_oxoDishSlope, DSd = Data_oxoDishSlopeSd, T = Template, subnumber = "oxoDishSlope")
    else if (LBLCurrentGraphData$getLabel() == "Sensor corrected data consumption") FPlotStandard(D = Data_oxoDishCons, DSd = Data_oxoDishConsSd, T = Template, subnumber = "oxoDishCons", altYLabel = SETAnalysisOpt$ConsCharacters["axis"])
    else if (LBLCurrentGraphData$getLabel() == "Average sensor corrected data") FPlotStandard(D = Data_oxoDishAv, DSd = Data_oxoDishSd, T = TemplateAverage, subnumber = "oxoDishAv")
    else if (LBLCurrentGraphData$getLabel() == "Average sensor corrected data smoothed") FPlotStandard(D = Data_oxoDishAvSm, T = TemplateAverage, subnumber = "oxoDishAvSm")
    else if (LBLCurrentGraphData$getLabel() == "Average sensor corrected data slope") FPlotStandard(D = Data_oxoDishAvSlope, DSd = Data_oxoDishAvSlopeSd, T = TemplateAverage, subnumber = "oxoDishAvSlope")
    else if (LBLCurrentGraphData$getLabel() == "Average sensor corrected data consumption") FPlotStandard(D = Data_oxoDishAvCons, DSd = Data_oxoDishAvConsSd, T = TemplateAverage, subnumber = "oxoDishAvCons", altYLabel = SETAnalysisOpt$ConsCharacters["axis"])
    else if (LBLCurrentGraphData$getLabel() == "Converted OxoPlate data") FPlotStandard(D = Data_oxoPlate, T = Template, subnumber = "oxoPlate")
    else if (LBLCurrentGraphData$getLabel() == "Unformatted OxoPlate data") FPlotStandard(D = Data_oxoPlateOrig, T = Template, subnumber = "oxoPlateOrig")
    else if (LBLCurrentGraphData$getLabel() == "OxoPlate data smoothed") FPlotStandard(D = Data_oxoPlateSm, T = Template, subnumber = "oxoPlateSm")
    else if (LBLCurrentGraphData$getLabel() == "OxoPlate data slope") FPlotStandard(D = Data_oxoPlateSlope, DSd = Data_oxoPlateSlopeSd, T = Template, subnumber = "oxoPlateSlope")
    else if (LBLCurrentGraphData$getLabel() == "OxoPlate data consumption") FPlotStandard(D = Data_oxoPlateCons, DSd = Data_oxoPlateConsSd, T = Template, subnumber = "oxoPlateCons", altYLabel = SETAnalysisOpt$ConsCharacters["axis"])
    else if (LBLCurrentGraphData$getLabel() == "Average OxoPlate data") FPlotStandard(D = Data_oxoPlateAv, DSd = Data_oxoPlateSd, T = TemplateAverage, subnumber = "oxoPlateAv")
    else if (LBLCurrentGraphData$getLabel() == "Average OxoPlate data smoothed") FPlotStandard(D = Data_oxoPlateAvSm, T = TemplateAverage, subnumber = "oxoPlateAvSm")
    else if (LBLCurrentGraphData$getLabel() == "Average OxoPlate data slope") FPlotStandard(D = Data_oxoPlateAvSlope, DSd = Data_oxoPlateAvSlopeSd, T = TemplateAverage, subnumber = "oxoPlateAvSlope")
    else if (LBLCurrentGraphData$getLabel() == "Average OxoPlate data consumption") FPlotStandard(D = Data_oxoPlateAvCons, DSd = Data_oxoPlateAvConsSd, T = TemplateAverage, subnumber = "oxoPlateAvCons", altYLabel = SETAnalysisOpt$ConsCharacters["axis"])
    else if (LBLCurrentGraphData$getLabel() == "Converted HydroPlate data") FPlotStandard(D = Data_hydroPlate, T = Template, subnumber = "hydroPlate")
    else if (LBLCurrentGraphData$getLabel() == "Unformatted converted HydroPlate data") FPlotStandard(D = Data_hydroPlateOrig, T = Template, subnumber = "hydroPlateOrig")
    else if (LBLCurrentGraphData$getLabel() == "Calibration values for HydroPlate data") FPlotStandard(D = Data_hydroPlateCal, T = data.frame(X = c("Imin", "Imax", "pH0", "dpH"), Name = c("Imin", "Imax", "pH0", "dpH"), Number = c(1,2,3,4), Colour = c("darkgrey", "black", "green", "red"), Linetype = c("solid", "solid", "solid", "solid")), subnumber = "hydroPlateCal")
    else if (LBLCurrentGraphData$getLabel() == "HydroPlate data smoothed") FPlotStandard(D = Data_hydroPlateSm, T = Template, subnumber = "hydroPlateSm")
    else if (LBLCurrentGraphData$getLabel() == "HydroPlate data slope") FPlotStandard(D = Data_hydroPlateSlope, DSd = Data_hydroPlateSlopeSd, T = Template, subnumber = "hydroPlateSlope")
    else if (LBLCurrentGraphData$getLabel() == "Average HydroPlate data") FPlotStandard(D = Data_hydroPlateAv, DSd = Data_hydroPlateSd, T = TemplateAverage, subnumber = "hydroPlateAv")
    else if (LBLCurrentGraphData$getLabel() == "Average HydroPlate data smoothed") FPlotStandard(D = Data_hydroPlateAvSm, T = TemplateAverage, subnumber = "hydroPlateAvSm")
    else if (LBLCurrentGraphData$getLabel() == "Average HydroPlate data slope") FPlotStandard(D = Data_hydroPlateAvSlope, DSd = Data_hydroPlateAvSlopeSd, T = TemplateAverage, subnumber = "hydroPlateAvSlope")
    else if (LBLCurrentGraphData$getLabel() == "Medium data") FPlotStandard(D = Data_medium, T = Template, subnumber = "medium")
    else if (LBLCurrentGraphData$getLabel() == "Unformatted medium data") FPlotStandard(D = Data_mediumOrig, T = Template, subnumber = "mediumOrig")
    else if (LBLCurrentGraphData$getLabel() == "Medium data smoothed") FPlotStandard(D = Data_mediumSm, T = Template, subnumber = "mediumSm")
    else if (LBLCurrentGraphData$getLabel() == "Medium data slope") FPlotStandard(D = Data_mediumSlope, DSd = Data_mediumSlopeSd, T = Template, subnumber = "mediumSlope")
    else if (LBLCurrentGraphData$getLabel() == "Medium data consumption") FPlotStandard(D = Data_mediumCons, DSd = Data_mediumConsSd, T = Template, subnumber = "mediumCons", altYLabel = SETAnalysisOpt$ConsCharacters["axis"])
    else if (LBLCurrentGraphData$getLabel() == "Average medium data") FPlotStandard(D = Data_mediumAv, DSd = Data_mediumSd, T = TemplateAverage, subnumber = "mediumAv")
    else if (LBLCurrentGraphData$getLabel() == "Average medium data smoothed") FPlotStandard(D = Data_mediumAvSm, T = TemplateAverage, subnumber = "mediumAvSm")
    else if (LBLCurrentGraphData$getLabel() == "Average medium data slope") FPlotStandard(D = Data_mediumAvSlope, DSd = Data_mediumAvSlopeSd, T = TemplateAverage, subnumber = "mediumAvSlope")
    else if (LBLCurrentGraphData$getLabel() == "Average medium data consumption") FPlotStandard(D = Data_mediumAvCons, DSd = Data_mediumAvConsSd, T = TemplateAverage, subnumber = "mediumAvCons", altYLabel = SETAnalysisOpt$ConsCharacters["axis"])
    else if (LBLCurrentGraphData$getLabel() == "Timeresolved IC50 data") FPlotIC50Time(D = Data_IC50)
    else if (LBLCurrentGraphData$getLabel() == "IC50 fitting data") FPlotIC50Fit(D = Data_IC50Models)
    Sys.sleep(.1)
    dev.off()
    print(paste(getwd(), SETDataOutput$folder, ENTExportGraph$getText(), sep="/"))
    POPExportGraph$destroy()
  } else POPExportGraph$destroy()
}))